function [dataTr, dataTe] = load_dataset(dset)
	directory = 'dataset/';
	dataset_name=strcat(directory, dset,'.mat');
	dataset_name = dataset_name{1};
	dset = dset{1};
	dataset = load(dataset_name);
	if strcmp(dset, 'coco_8') | strcmp(dset, 'coco_11')
		dataTr = dataset.coco.train;
		dataTr = dataTr(:,randperm(size(dataTr,2)));
		dataTr = dataTr(:,1:100000);
		dataTe = dataset.coco.test;
		dataTe = dataTe(:,randperm(size(dataTe,2)));
	end
	if strcmp(dset, 'sun_8') | strcmp(dset, 'sun_11')
		dataTr = dataset.sun.train;
		dataTr = dataTr(:,randperm(size(dataTr,2)));
		dataTr = dataTr(:,1:100000);
		dataTe = dataset.sun.test;
		dataTe = dataTe(:,randperm(size(dataTe,2)));
	end
	if strcmp(dset, 'vgg2_8') | strcmp(dset, 'vgg2_11')
		dataTr = dataset.vgg2.train;
		dataTr = dataTr(:,randperm(size(dataTr,2)));
		dataTr = dataTr(:,1:100000);
		dataTe = dataset.vgg2.test;
		dataTe = dataTe(:,randperm(size(dataTe,2)));
	end
	if strcmp(dset, 'voc_8') | strcmp(dset, 'voc_11')
		dataTr = dataset.voc.train;
		dataTr = dataTr(:,randperm(size(dataTr,2)));
		dataTr = dataTr(:,1:100000);
		dataTe = dataset.voc.test;
		dataTe = dataTe(:,randperm(size(dataTe,2)));
	end
	if strcmp(dset, 'bsds500_8') | strcmp(dset, 'bsds500_11')
		dataTr = dataset.bsds500.train;
		dataTr = dataTr(:,randperm(size(dataTr,2)));
		dataTr = dataTr(:,1:100000);
		dataTe = dataset.bsds500.test;
		dataTe = dataTe(:,randperm(size(dataTe,2)));
	end
	if strcmp(dset, 'bsds500_31') | strcmp(dset, 'bsds500_64')
		dataTr = dataset.bsds500.train;
		dataTr = dataTr(:,randperm(size(dataTr,2)));
		dataTr = dataTr(:,1:160000);
		dataTr = dataTr(:,1:100000);
		dataTe = dataset.bsds500.test;
		dataTe = dataTe(:,randperm(size(dataTe,2)));
		dataTe = dataTe(:,1:16000);
	end

	if strcmp(dset, 'cifar100_31') | strcmp(dset, 'cifar100_98') | strcmp(dset, 'cifar100')
		dataTr = dataset.cifar100.train;
		dataTr = dataTr(:,randperm(size(dataTr,2)));
		dataTe = dataset.cifar100.test;
		dataTe = dataTe(:,randperm(size(dataTe,2)));
	end

	if strcmp(dset, 'cifar10_33') | strcmp(dset, 'cifar10_89') | strcmp(dset, 'cifar10')
		dataTr = dataset.cifar10.train;
		dataTr = dataTr(:,randperm(size(dataTr,2)));
		dataTe = dataset.cifar10.test;
		dataTe = dataTe(:,randperm(size(dataTe,2)));
	end

	if strcmp(dset, 'coco8') | strcmp(dset, 'coco11')| strcmp(dset, 'coco32')
		data = dataset.data;
		data = data(:,randperm(size(data,2)));
		dataTr = data(:,1:100000);
		dataTe = data(:,1+100000:end);
	end

	if strcmp(dset, 'letter_16')
		dataTr = dataset.letter.train;
		dataTr = dataTr(:,randperm(size(dataTr,2)));
		dataTe = dataset.letter.test;
		dataTe = dataTe(:,randperm(size(dataTe,2)));
	end

	if strcmp(dset, 'magic_10')
		dataTr = dataset.magic.train;
		dataTr = dataTr(:,randperm(size(dataTr,2)));
		dataTe = dataset.magic.test;
		dataTe = dataTe(:,randperm(size(dataTe,2)));
	end

	if strcmp(dset, 'mnist_154') | strcmp(dset, 'mnist_51')
		dataTr = dataset.mnist.train;
		dataTr = dataTr(:,randperm(size(dataTr,2)));
		dataTe = dataset.mnist.test;
		dataTe = dataTe(:,randperm(size(dataTe,2)));
	end

	if strcmp(dset, 'stl_10_82')
		dataTr = dataset.stl.train;
		dataTr = dataTr(:,randperm(size(dataTr,2)));
		dataTe = dataset.stl.test;
		dataTe = dataTe(:,randperm(size(dataTe,2)));
	end

	if strcmp(dset, 'sun8') | strcmp(dset, 'sun11')| strcmp(dset, 'sun32')
		data = dataset.data;
		data = data(:,randperm(size(data,2)));
		dataTr = data(:,1:100000);
		dataTe = data(:,1+100000:end);
	end

	if strcmp(dset, 'svhn_52') | strcmp(dset, 'svhn_110')
		dataTr = dataset.svhn.train;
		dataTr = dataTr(:,randperm(size(dataTr,2)));
		dataTe = dataset.svhn.test;
		dataTe = dataTe(:,randperm(size(dataTe,2)));
	end

	if strcmp(dset, 'usps_22') | strcmp(dset, 'usps_88')
		dataTr = dataset.usps.train;
		dataTr = dataTr(:,randperm(size(dataTr,2)));
		dataTe = dataset.usps.test;
		dataTe = dataTe(:,randperm(size(dataTe,2)));
	end

	if strcmp(dset, 'vgg8') | strcmp(dset, 'vgg11')| strcmp(dset, 'vgg32')
		data = dataset.data;
		data = data(:,randperm(size(data,2)));
		dataTr = data(:,1:100000);
		dataTe = data(:,1+100000:end);
	end

	if strcmp(dset, 'voc8') | strcmp(dset, 'voc11')| strcmp(dset, 'voc32')
		data = dataset.data;
		data = data(:,randperm(size(data,2)));
		dataTr = data(:,1:100000);
		dataTe = data(:,1+100000:end);
	end

	if strcmp(dset, 'wave_21')
		dataTr = dataset.wave.train;
		dataTr = dataTr(:,randperm(size(dataTr,2)));
		dataTe = dataset.wave.test;
		dataTe = dataTe(:,randperm(size(dataTe,2)));
	end

	if strcmp(dset, 'yearprediction_45') | strcmp(dset, 'yearprediction_90')
		dataTr = dataset.yearprediction.train;
		dataTr = dataTr(:,randperm(size(dataTr,2)));
		dataTr = dataTr(:,1:100000);
		dataTe = dataset.yearprediction.test;
		dataTe = dataTe(:,randperm(size(dataTe,2)));
	end
end
