function lp = wishpdfln(X,A,B,inverse)
%WISHPDFLN    Logarithm of Wishart probability density function.
%  See WISHPDF for argument description.

% Written by Tom Minka
% (c) Microsoft Corporation. All rights reserved.

a = A;

if nargin < 3
  B = [];
end
if nargin < 4
  inverse = 0;
end

if inverse
  X = inv(X);
end
if isempty(B)
  XB = X;
  logDetB = 0;
else
  XB = X*B;
  logDetB = logdetLS(B);
end
d = rows(X);
d2 = (d+1)/2;
if inverse
  d2 = -d2;
end
% [V1,D1] = eig(XB);
% d1 = min(D1(:));
% d2 = max(D1(:));
% disp(strcat('d1w: ',num2str(d1),', d2w: ',num2str(d2)));
% disp(XB)
logDetXB = (a-d2)*logdetLS(XB);
lp = logDetXB - trace(XB) + d2*logDetB - gammalnp(a,d);
