import torch
from torch.autograd import Function
import time


class LogdetFunction(Function):

    @staticmethod
    def forward(ctx, tensor):
        start = time.time()
        ctx.save_for_backward(tensor)
        sld = torch.slogdet(tensor)
        sld = sld[1]
        end = time.time()
        return sld

    @staticmethod
    def backward(ctx, grad_output):
        start = time.time()
        tensor = ctx.saved_tensors
        tensor = tensor[0]
        grad = tensor.inverse()
        grad = torch.transpose(grad, 0, 1)
    
        if not grad_output:
            grad = grad_output * grad
        end = time.time()
        return grad

logdet = LogdetFunction.apply
