import torch
import torch.nn as nn
import numpy as np
import math
from model.logdet import logdet


class MVN(nn.Module):
    def __init__(self, device):
        super(MVN, self).__init__()
        dimension = 0
        self.dimension = dimension
        self.mu = nn.Parameter(torch.zeros(dimension, dtype=torch.float, device=device))
        self.d = nn.Parameter(torch.zeros(dimension, dtype=torch.float, device=device))

    def __init__(self, dimension, device):
        super(MVN, self).__init__()
        self.dimension = dimension
        if device.type == 'cuda':
            self.mu = nn.Parameter(torch.randn([dimension], dtype=torch.float).cuda())
            self.d = nn.Parameter(torch.abs(torch.randn([dimension], dtype=torch.float)).cuda())
        else:
            self.mu = nn.Parameter(torch.randn([dimension], dtype=torch.float))
            self.d = nn.Parameter(torch.abs(torch.randn([dimension], dtype=torch.float)))

    def ll(self, U, x):
        llvector = 0

        sld = torch.slogdet(U)
        d_exp = torch.exp(self.d)
        log_z = -self.dimension * np.log(2 * np.pi) + torch.sum(torch.log(d_exp)) + 2 * sld[1]

        xu = torch.matmul(x, U)
        xu2 = torch.pow(xu, 2)
        log_likelihood_vector = log_z - torch.matmul(xu2, d_exp)
        mu = torch.matmul(self.mu, U)
        mu2 = torch.pow(mu, 2)
        log_likelihood_vector -= torch.matmul(mu2, d_exp)
        log_likelihood_vector += 2 * torch.matmul(xu, self.mu*d_exp)
        log_likelihood_vector *= 0.5
        return log_likelihood_vector


    def nll(self, U, x):
        start = time.time()
        end = time.time()
        return -self.ll(U, x)

