import torch
import numpy as np
from model.utils import cov


class Prior:
    def __init__(self, data=None, num=None):
        if not num:
            self.mup = 0
            self.kp = 0
            self.nup = 0
            self.sp = 0
            self.Sp = 0
            self.Spi = 0
            self.ap = 0
            return
        ndata, dim = data.shape
        self.mup = torch.mean(data, 0)
        self.kp = 0.01
        self.nup = dim + 2
        self.sp = torch.sum(torch.diag(cov(data))) / dim / (torch.pow(num.double(), 2.0 / dim))
        self.Sp = cov(data) / (torch.pow(num.double(), 2.0 / dim))
        self.Spi = torch.inverse(self.Sp)
        self.ap = torch.ones(num) + 1e-2
